/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: timers.h,v 1.1.1.1 1993/04/18 16:14:54 mura Exp $
 */

#ifndef __sys_timers_h__
#define __sys_timers_h__

#ifndef __cdecl_h__
#include <cdecl.h>
#endif

#define DELIVERY_SIGNALS 1
#define TIMEOFDAY 1

struct timespec {
    unsigned long tv_sec;
    long tv_nsec;
};

struct itimespec {
    struct timespec it_interval;
    struct timespec it_value;
};

typedef int_ timer_t;

EXT (int_ getclock (int_, struct timespec *));
EXT (int_ gettimer (timer_t, struct itimespec *));
EXT (int_ reltimer (timer_t, struct itimespec *, struct itimespec *));
EXT (int_ rmtimer (timer_t));
EXT (int_ setclock (int_, struct timespec *));
EXT (timer_t mktimer (int_, int_, void *));

#endif
